Index: /trunk/SophyaPI/PIext/cxxexecutor.cc
===================================================================
--- /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 1288)
+++ /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 1289)
@@ -15,5 +15,5 @@
   : mUserCodeFn(""), mUserFctFn("")
   , mCompOpt(""), mLinkOpt(""), mMyLibs("")
-  , mDefTmp(""), mDefRoot("cxx_spiapp"), mDefFunc("usercxx"), mPrtLevel(1)
+  , mDefTmp(""), mDefRoot("cxx_spiapp"), mDefFunc("usercxx"), mPrtLevel(2)
 {
 mIncList.resize(0);
@@ -105,4 +105,12 @@
 mpiac->RegisterCommand(kw, usage, this, hgrp);
 
+
+kw = "c++prtlevel";
+usage = "c++prtlevel: Print level\n";
+usage+= "Usage: c++prtlevel prtlevel\n";
+usage+= "       prtlevel=0 : minimum printing\n";
+usage+= "       prtlevel=1 : + compiler/linker output\n";
+usage+= "       prtlevel=2 : + full infos (default)";
+mpiac->RegisterCommand(kw, usage, this, hgrp);
 
 }
@@ -193,4 +201,13 @@
     {cout<<"c++mylibs "<<GetLinkLibs()<<endl; return(0);}
   FillLinkLibs(tokens);
+
+} else if(kw == "c++prtlevel") {
+  if(tokens.size()==1) if(tokens[0]=="-?")
+    {cout<<"c++prtlevel prtlevel = "<<mPrtLevel<<endl; return(0);}
+  if(tokens.size()>0) {
+    int lp=atoi(tokens[0].c_str()); if(lp<0) lp=0;
+    mPrtLevel=(uint_2) lp;
+  } else mPrtLevel=2;
+
 }
 
@@ -262,9 +279,9 @@
 os<<"}"<<endl;
 
-if(mPrtLevel)
+if(mPrtLevel>1)
   cout<<"File "<<cfilename<<" for function "<<func<<" created :"<<endl;
-if(mPrtLevel && mUserCodeFn.size()>0)
+if(mPrtLevel>1 && mUserCodeFn.size()>0)
   cout<<"  User code was in file "<<mUserCodeFn<<endl;
-if(mPrtLevel && mUserFctFn.size()>0)
+if(mPrtLevel>1 && mUserFctFn.size()>0)
   cout<<"  User function code was in file "<<mUserFctFn<<endl;
 return 0;
@@ -408,5 +425,5 @@
              <<mUserCodeFn<<endl;  mUserCodeFn = ""; return 1;}
 os<<code<<endl;
-if(mPrtLevel)
+if(mPrtLevel>1)
   cout<<"User code filled from standard input into "<<mUserCodeFn<<endl;
 return 0;
@@ -425,5 +442,5 @@
              <<mUserFctFn<<endl;  mUserFctFn = ""; return 1;}
 os<<userfctcode<<endl;
-if(mPrtLevel)
+if(mPrtLevel>1)
   cout<<"User Function code filled from standard input into "<<mUserFctFn<<endl;
 return 0;
@@ -435,5 +452,5 @@
 {
 mUserCodeFn = filename;
-if(mPrtLevel && mUserCodeFn.size()>0)
+if(mPrtLevel>1 && mUserCodeFn.size()>0)
   cout<<"User code filled from file "<<mUserCodeFn<<endl;
 return 0;
@@ -445,5 +462,5 @@
 {
 mUserFctFn = filefctname;
-if(mPrtLevel && mUserFctFn.size()>0)
+if(mPrtLevel>1 && mUserFctFn.size()>0)
   cout<<"User Function code filled from file "<<mUserFctFn<<endl;
 return 0;
@@ -462,10 +479,11 @@
 {
 if(rootfilename.size()<1) rootfilename = mDefTmp + mDefRoot;
-if(mPrtLevel) cout<<"Compile "<<rootfilename<<endl;
+if(mPrtLevel>1) cout<<"Compile "<<rootfilename<<endl;
 
 int rc;
 CxxCompilerLinker cxx;
 if(mDefTmp.size()>0) cxx.SetTmpDir(mDefTmp);
-cxx.SetVerbose(true);
+if(mPrtLevel>0) cxx.SetVerbose(true);
+  else          cxx.SetVerbose(false);
 
 // Compilation
@@ -474,5 +492,5 @@
 cxx.AddCompileOptions(mCompOpt);
 rc = cxx.Compile(fcc,fo);
-if(mPrtLevel) cout << "Compilation rc = "<<rc<< endl;
+if(mPrtLevel>1) cout << "Compilation rc = "<<rc<< endl;
 if(rc) return 1;
 
@@ -484,5 +502,5 @@
 cxx.AddLinkOptions(mMyLibs);
 rc = cxx.BuildSO(fo,fso);
-if(mPrtLevel) cout << "Shared Library rc = "<<rc<< endl;
+if(mPrtLevel>1) cout << "Shared Library rc = "<<rc<< endl;
 if(rc) return 2;
 
@@ -495,5 +513,5 @@
 //{
 //if(rootfilename.size()<1) rootfilename = mDefRoot;
-//if(mPrtLevel) cout<<"Compile: "<<rootfilename<<endl;
+//if(mPrtLevel>1) cout<<"Compile: "<<rootfilename<<endl;
 //int rc = 0;
 //rc = CrMakefile();
@@ -567,5 +585,5 @@
 string toks = libname + " " + func;
 int rc = mpiac->ExecuteCommand(key,arg,toks);
-if(mPrtLevel) cout<<"Link from "<<libname<<" for function "<<func
+if(mPrtLevel>1) cout<<"Link from "<<libname<<" for function "<<func
                   <<" (rc="<<rc<<")"<<endl;
 return 0;
Index: /trunk/SophyaPI/PIext/cxxexecutor.h
===================================================================
--- /trunk/SophyaPI/PIext/cxxexecutor.h	(revision 1288)
+++ /trunk/SophyaPI/PIext/cxxexecutor.h	(revision 1289)
@@ -25,5 +25,5 @@
   virtual int Execute(string& keyw,vector<string>& args, string& toks);
 
-  inline void SetPrtLevel(uint_2 lp=0) {mPrtLevel = lp;}
+  inline void SetPrtLevel(uint_2 lp=2) {mPrtLevel = lp;}
 
   int  ExecuteCXX(string usercode,string userfct="");