Index: trunk/SophyaProg/Tests/scanfits.cc
===================================================================
--- trunk/SophyaProg/Tests/scanfits.cc	(revision 1306)
+++ 	(revision )
@@ -1,61 +1,0 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <math.h>
-#include <iostream.h>
-
-#include "histinit.h"
-#include "dvlist.h"
-#include "ntuple.h"
-#include "xntuple.h"
-#include "fitsxntuple.h"
-#include "fitsntuple.h"
-
-int main(int narg, char *arg[])
-{
-  if (narg < 2) {
-    cerr << "scanfits/Erreur arg - Usage scanfits nomfits \n" << endl;
-    exit(0);
-  }
-  try {
-    SophyaInit();
-    string flnm = arg[1];
-    int nbblk = FitsInFile::NbBlocks(arg[1]);
-    cout << " :::: File " << flnm << " has " << nbblk << " blocks " << endl;
-    DVList header;
-    FitsFile::FitsExtensionType exttype;
-    FitsFile::FitsDataType datatype;
-
-    cout << " FitsFile::FitsExtensionType : FitsExtensionType_IMAGE= " <<
-      (int)FitsFile::FitsExtensionType_IMAGE << 
-      "  FitsExtensionType_ASCII_TBL= " << (int)FitsFile::FitsExtensionType_ASCII_TBL <<
-      "  FitsExtensionType_BINARY_TBL= " << (int)FitsFile::FitsExtensionType_BINARY_TBL << endl;
-    cout << " FitsFile::FitsDataType: FitsDataType_double= " <<
-      (int)FitsFile::FitsDataType_double << 
-      " FitsDataType_float= " << (int)FitsFile::FitsDataType_float <<
-      " FitsDataType_int= " << (int)FitsFile::FitsDataType_int <<
-      " FitsDataType_char= " << (int)FitsFile::FitsDataType_char <<
-      " FitsDataType_ASCII= " << (int)FitsFile::FitsDataType_ASCII << endl << endl;
-
-    int naxis;
-    vector<int> axis;
-    for(int i=1; i<=nbblk; i++) {
-      FitsInFile::GetBlockType(arg[1], i, exttype, naxis, axis, datatype, header);
-      cout << " --------- Header Num " << i << " Type " << (int)exttype 
-	   << " NAxis= " << naxis << " (" << axis.size() << " )" 
-	   << " DataType= " << (int)datatype << endl;
-      for(int j=0; j<axis.size(); j++) cout  << axis[j] << " x "  ;
-      cout << endl;
-      cout << header << endl;
-      cout << "----------------------------------------------------" << endl;
-    } 
- 
-  }
-  catch (PThrowable & exc) {
-    cerr << " Catched Exception " << (string)typeid(exc).name()
-         << " - Msg= " << exc.Msg() << endl;
-  }
-  catch (...) {
-    cerr << " some other exception was caught ! " << endl;
-  }
-
-}
Index: trunk/SophyaProg/Tests/scanppf.cc
===================================================================
--- trunk/SophyaProg/Tests/scanppf.cc	(revision 1306)
+++ 	(revision )
@@ -1,80 +1,0 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <typeinfo>
-#include <iostream.h>
-#include <string>
-
-#include "ppersist.h"
-#include "anydataobj.h"
-#include "sambainit.h"
-
-#ifdef __MWERKS__
-#include <console.h>
-#endif
-
-int main(int narg, char* arg[])
-{
-
-#ifdef __MWERKS__
-narg = ccommand(&arg);
-#endif
-
-SambaInitiator smbinit;
-
-if ((narg < 2) || (strcmp(arg[1],"-h") == 0) ) {
-  cerr << " Usage: scanppf filename [s/n/a0/a1/a2/a3] \n" 
-       << "   s[=default} : Sequential reading of objects \n" 
-       << "   n : Object reading at NameTags \n"
-       << "   a0...a3 : Tag List with PInPersist.AnalyseTags(0...3) \n" << endl;
-  exit(0);
-  }
-
-try {
-  string flnm = arg[1];
-  bool seq=true;
-  bool ana=false;
-  int analev = 0;
-  string opt = "s";
-  if (narg > 2) opt = arg[2];
-  
-  if (opt == "n")  seq = false;
-  else if (opt[0] == 'a') {  ana = true;  analev = opt[1]-'0'; }
-
-  if (ana)   cout << " Analyse PInPersist( " << flnm << ")  Level=" << analev << endl;
-  else { 
-    if (!seq) cout << "PInPersist( " << flnm << ") Object Reading at NameTags " << endl;
-    else  cout << "PInPersist( " << flnm << ") Sequential Object Reading " << endl;
-  }
-   
-  PPersist* op = NULL;
-  cout << " Opening PPF file " << flnm << endl; 
-  PInPersist s(flnm);
-
-  if (ana) s.AnalyseTags(analev);   // Analysing all tags in file 
-
-  else {
-    cout << " Version= " << s.Version() << " CreationDate= " << s.CreationDateStr() << endl;
-    int nt = s.NbTags();
-    cout << " Number of tags in file = " << nt << endl;
-    if ( seq || (nt < 1) ) {
-      while (1) {
-	op = s.ReadObject();
-	cout << " Object Type " << typeid(*op).name() << endl;
-	if (op) delete op;
-      }
-    }
-    for(int i=0; i<nt; i++) {
-      cout << ">>> TagNum= " << i << " TagName= " << s.GetTagName(i) << endl;
-      s.GotoTagNum(i);
-      op = s.ReadObject();
-      cout << " Object Type " << typeid(*op).name() << endl;
-      if (op) delete op;
-    }
-  }
-}
-catch (PThrowable pex) {
-  cerr << " scanppf/Error - Exception catched " << pex.Msg() << endl;
-}
-
-cout << " ----------- End of scanppf ------------- " << endl;
-}